unit u_01_single_touch_wm_mouse;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Splitter1: TSplitter;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClick(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses TypInfo, Vcl.Touch.Gestures;

  {$R *.dfm}
    type t_shift_type= (ssShift, ssAlt, ssCtrl,
            ssLeft, ssRight, ssMiddle, ssDouble, ssTouch, ssPen, ssCommand);
         t_shift_type_set= set of t_shift_type;

    function f_shift_type_name(p_shift_type: t_shift_type): String;
      begin
        Result:= GetEnumName(TypeInfo(t_shift_type), Integer(p_shift_type));
      end;

    function f_shift_state_set(p_shift_state_set: tShiftState): String;
      var l_shift_type: t_shift_type;
          l_shift_type_set: t_shift_type_set;
      begin
        Result:= '';

        Move(p_shift_state_set, l_shift_type_set, SizeOf(t_shift_type_set));

        for l_shift_type:= ssShift to ssCommand do
          if l_shift_type in l_shift_type_set
            then Result:= Result+ f_shift_type_name(l_shift_type)+ ' ';
      end; // f_shift_state_set

    var g_gesture_count: integer= 0;
        g_event_count: Integer= 0;


    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end;

    procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
      begin
        display(Format('%3d %-15s %4d %4d %s',
            [g_event_count, 'MouseDown', X, Y, f_shift_state_set(Shift)]));
        Inc(g_event_count);
      end;

    procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
        Y: Integer);
      begin
        display(Format('%3d %-15s %4d %4d %s',
            [g_event_count, 'MouseMove', X, Y, f_shift_state_set(Shift)]));
        Inc(g_event_count);
      end;

    procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
      begin
        display(Format('%3d %-15s %4d %4d %s',
            [g_event_count, 'MouseUp', X, Y, f_shift_state_set(Shift)]));
        Inc(g_event_count);
      end;

    procedure TForm1.FormClick(Sender: TObject);
      begin
        display(Format('%3d %-15s ',
            [g_event_count, 'Click']));
        Inc(g_event_count);
      end;

    procedure TForm1.FormDblClick(Sender: TObject);
      begin
        display(Format('%3d %-15s ',
            [g_event_count, 'DblClick']));
        Inc(g_event_count);
      end;

end.
